#Boa:Frame:Frame1
# _*_ coding: iso-8859-1 _*_


import wx
from cfgparse import ConfigParser

from gest_app import GestApp

# ajout de "serveur"  la fonction create pour passer l'adresse  Frame1
# serveur = ('ip', int('port'))
def create(parent):
    return Frame1(parent)

[wxID_FRAME1, wxID_FRAME1ACTUALISE_BTN, wxID_FRAME1INST_BTN, 
 wxID_FRAME1LANCE_BTN, wxID_FRAME1LISTCTRLAPPS, wxID_FRAME1STATICTEXT1, 
 wxID_FRAME1STATUSBAR1, 
] = [wx.NewId() for _init_ctrls in range(7)]

class Frame1(wx.Frame):
    def _init_coll_listCtrlApps_Columns(self, parent):
        # generated method, don't edit

        parent.InsertColumn(col=0, format=wx.LIST_FORMAT_LEFT, heading='Nom',
              width=110)
        parent.InsertColumn(col=1, format=wx.LIST_FORMAT_LEFT,
              heading='Description', width=294)

    def _init_coll_statusBar1_Fields(self, parent):
        # generated method, don't edit
        parent.SetFieldsCount(1)

        parent.SetStatusText(number=0, text='Pr\xeat')

        parent.SetStatusWidths([-1])

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Frame.__init__(self, id=wxID_FRAME1, name='', parent=prnt,
              pos=wx.Point(279, 114), size=wx.Size(465, 509),
              style=wx.SYSTEM_MENU | wx.CLIP_CHILDREN | wx.CAPTION | wx.CLOSE_BOX | wx.MINIMIZE_BOX,
              title="Gestion d'applications")
        self.SetClientSize(wx.Size(457, 475))
        self.SetBackgroundColour(wx.Colour(255, 255, 209))
        self.SetIcon(wx.Icon('eole.ico',wx.BITMAP_TYPE_ICO))
        self.Center(wx.BOTH)

        self.inst_btn = wx.Button(id=wxID_FRAME1INST_BTN,
              label='Installer / R\xe9parer', name='inst_btn', parent=self,
              pos=wx.Point(168, 360), size=wx.Size(128, 24), style=0)
        self.inst_btn.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL, False,
              'Tahoma'))
        self.inst_btn.Enable(False)
        self.inst_btn.Bind(wx.EVT_BUTTON, self.OnInst_btnButton,
              id=wxID_FRAME1INST_BTN)

        self.lance_btn = wx.Button(id=wxID_FRAME1LANCE_BTN, label='Lancer',
              name='lance_btn', parent=self, pos=wx.Point(168, 404),
              size=wx.Size(128, 24), style=0)
        self.lance_btn.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL,
              False, 'Tahoma'))
        self.lance_btn.Enable(False)
        self.lance_btn.Show(False)
        self.lance_btn.Bind(wx.EVT_BUTTON, self.OnLance_btnButton,
              id=wxID_FRAME1LANCE_BTN)

        self.staticText1 = wx.StaticText(id=wxID_FRAME1STATICTEXT1,
              label='S\xe9lectionnez une application', name='staticText1',
              parent=self, pos=wx.Point(138, 17), size=wx.Size(184, 16),
              style=0)
        self.staticText1.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD,
              False, 'Tahoma'))

        self.actualise_btn = wx.Button(id=wxID_FRAME1ACTUALISE_BTN,
              label='Actualiser la liste', name='actualise_btn', parent=self,
              pos=wx.Point(336, 304), size=wx.Size(96, 20), style=0)
        self.actualise_btn.SetFont(wx.Font(8, wx.SWISS, wx.NORMAL, wx.NORMAL,
              False, 'Tahoma'))
        self.actualise_btn.Bind(wx.EVT_BUTTON, self.OnActualise_btnButton,
              id=wxID_FRAME1ACTUALISE_BTN)

        self.listCtrlApps = wx.ListCtrl(id=wxID_FRAME1LISTCTRLAPPS,
              name='listCtrlApps', parent=self, pos=wx.Point(24, 48),
              size=wx.Size(408, 248), style=wx.LC_REPORT)
        self._init_coll_listCtrlApps_Columns(self.listCtrlApps)
        self.listCtrlApps.Bind(wx.EVT_LIST_ITEM_SELECTED,
              self.OnListCtrlAppsListItemSelected, id=wxID_FRAME1LISTCTRLAPPS)

        self.statusBar1 = wx.StatusBar(id=wxID_FRAME1STATUSBAR1,
              name='statusBar1', parent=self, style=0)
        self._init_coll_statusBar1_Fields(self.statusBar1)
        self.SetStatusBar(self.statusBar1)

    def __init__(self, parent):
        self._init_ctrls(parent)
        self.prefs_file = "app-install.ini"
        self.serveur = self.get_pref(self.prefs_file, "serveur")
        self.port = int(self.get_pref(self.prefs_file, "port"))
        self.sel_app = None
        self._init_apps()

    def _init_apps(self):
        self.inst_btn.Disable()
        self.lance_btn.Disable()
        self.statusBar1.SetStatusText(number=0, text='Pr\xeat')
        self.gest = GestApp(self.serveur, self.port)
        self.gest.get_apps(self.return_apps, self.serv_err)

###############################
#  Fonctions vnementielles  #
###############################
    def OnInst_btnButton(self, event):
        self.inst_btn.Disable()
        self.lance_btn.Disable()
        self.statusBar1.SetStatusText(number=0, text='Installation en cours')
        self.inst_btn
        self.gest.inst_app(self.sel_app, self.return_inst_app, self.serv_err)
        
    def OnLance_btnButton(self, event):
        return

    def OnListCtrlAppsListItemSelected(self, event):
        self.item = event.m_itemIndex
        if self.get_selection():
            self.inst_btn.Enable()
            self.lance_btn.Enable()
        
    def get_selection(self):
        #le clic a-t-il slectionn qqchose ?
        try:
            self.sel_app = self.listCtrlApps.GetItem(self.item, 0).GetText()
            self.app_item = self.item
            return True
        except: return False
        
    def OnActualise_btnButton(self, event):
        self._init_apps()


###############################
#     Fonctions de retour     #
###############################
    def return_apps(self, apps):
        self.apps = apps
        self.listCtrlApps.DeleteAllItems()
        if not apps or type(apps) != dict:
            self.listCtrlApps.Append(('Erreur', ''))
            print apps
            return
        for i in apps.keys():
            titre = apps[i]['titre']
            self.listCtrlApps.Append((i, titre.encode('iso8859-1')))


    def return_inst_app(self, ret, app):
        self. _init_apps()
        if ret == 0: self.green_alert(u'"%s" : Installation termine'%app)
        else: self.red_alert(u'"%s" : Installation choue !'%app)

###############################
#    Fonctions diverses       #
###############################
    def get_pref(self, fich, pref):
        """lit le fichier des prfrences et retourne la valeur du paramtre
        """
        c = ConfigParser()
        c.add_file(fich)
        return c.add_option(pref).get().lower().strip()

    def green_alert(self, msg):
        self.gen_msg(msg, wx.ICON_INFORMATION)
    
    def red_alert(self, msg):
        self.gen_msg(msg, wx.ICON_ERROR)
    
    def gen_msg(self, msg, type):
        """affiche une MSGBOX de type ERROR
        """
        if type == wx.ICON_ERROR: titre = 'Erreur'
        else: titre = 'Information'
        dlg = wx.MessageDialog(self, msg,
          titre, wx.OK | type)
        try:
            dlg.ShowModal()
        finally:
            dlg.Destroy()

    def serv_err(self, eh, msg):
        self.red_alert(msg)


