#!/usr/bin/env python
#Boa:App:BoaApp
# _*_ coding: iso-8859-15 _*_


import wx
import os
import sys


#import CliScribe_Setup_mainf


modules ={'CliScribe_Setup_mainf': [1,
                           'Main frame of Application',
                           'CliScribe_Setup_mainf.py']}

class BoaApp(wx.App):
    def OnInit(self):
        if 'python' not in os.path.split(sys.executable)[1].lower():
            os.chdir(os.path.dirname(sys.executable))
        banniere = "banniere.jpg"
        bmp = wx.Image(banniere).ConvertToBitmap()
        splash = wx.SplashScreen(bmp,
            wx.SPLASH_CENTRE_ON_SCREEN | wx.SPLASH_TIMEOUT,6000, None, -1)
        wx.BeginBusyCursor()
        splash.Show()

        from twisted.internet import wxreactor
        wxreactor.install()
        import CliScribe_Setup_mainf
        
        wx.InitAllImageHandlers()
        self.main = CliScribe_Setup_mainf.create(None)
        self.main.Show()
        self.SetTopWindow(self.main)
        splash.Close()
        wx.EndBusyCursor()
        return True

def main():
    application = BoaApp(0)
    
    from twisted.internet import reactor
    
    reactor.registerWxApp(application)
    reactor.run()

if __name__ == '__main__':
    main()
