# _*_ coding: iso-8859-1 _*_
#!/usr/bin/env python

import logging

import win32api as wa

import background


"""
Actions logon effectues par l'utilisateur :
- fond d'cran
- imprimantes
- ini
- js
"""


def logon(logon_dict):
    sid = logon_dict['usersid']
    gm = logon_dict['GM']
    gu = logon_dict['GU']
    computer = wa.GetComputerName()
    userlname = logon_dict['userLname']
    message = [userlname, 'Bureau : %s'%gu, 'Groupe de machine : %s'%gm, 'Poste : %s'%computer]
    background.set_backgrnd(sid, message)
    
    
    
def applique_registre(logon_dict):
    logging.info('Application de cls de registre machine')
    clean_machine_reg()
    put_regs(logon_dict['regedit_machine'])
    logging.info('Cls de registre machine appliquees')
    if logoff(): return
    logging.info('Application de cls de registre utilisateur')
    clean_user_reg()
    put_regs(logon_dict['regedit_user'])
    logging.info('Cls de registre utilisateur appliquees')

def logoff():
    if get_option(r'SOFTWARE\CRDP Bretagne\ESU', 'DisconnectBadUsers') == '1':
        logging.info("Deconnexion de l'utilisateur")
        opts = wc.EWX_LOGOFF | wc.EWX_FORCE
        wa.ExitWindowsEx(opts,0)
        return True
    return False

def timesync(inst_path):
    time_server = get_option(r'SOFTWARE\CRDP Bretagne\ESU', 'TimeServer')
    if time_server:
        logging.info('Synchornisation horaire sur "%s"'%time_server)
        cmd = os.path.join(inst_path, 'esuNtpC.exe')
        wa.WinExec('%s /h:%s'%(cmd, time_server))

def privilege(logon_dict, nom_scribe):
    username = logon_dict['username']
    for priv, value in logon_dict['privilege']:
        if value == 'ADD':
            logging.info('Application du privilege "%s"'%privilege)
            AjouterPrivilege(username, privilege, nom_scribe)


def put_acl(logon_dict):
    logging.info("Application d'ACLs")
    pass