# _*_ coding: iso-8859-1 _*_
#!/usr/bin/env python

import os, shutil, sys

# pour l'import de win32com.shell
try:
    import modulefinder
    import win32com
    for p in win32com.__path__[1:]:
        modulefinder.AddPackagePath("win32com", p)
    for extra in ["win32com.shell"]: #,"win32com.mapi"
        __import__(extra)
        m = sys.modules[extra]
        for p in m.__path__[1:]:
            modulefinder.AddPackagePath(extra, p)
except ImportError:
    # no build path setup, no worries.
    pass
# #############

from distutils.core import setup
import py2exe

dist_dir = "gestion-postes"
if os.path.exists(dist_dir):
    shutil.rmtree(dist_dir)

if os.path.exists("build"):
    shutil.rmtree("build")

opts = {"py2exe": {
                   "dist_dir": dist_dir,
                   "packages":["encodings",],
                   "optimize":2,
                    }
        }

setup(name="Gestion des postes clients windows",
      options=opts,
      version="1.0",
      description="",
      author="Eole",
      author_email="eole@ac-dijon.fr",
      url="http://eole.orion.education.fr/diffusion",
      windows=[{
          "script":'gestion-postes.py',
          "icon_resources":[(1, "eole.ico")]
          }],
      data_files=[("", []),("",
                   ["eole_conf.vnc", "banniere.jpg", "eole.ico", "gdiplus.dll", "msvcp71.dll", "vncviewer.exe", "vnclang.dll", "gestion-postes.exe.manifest"])] # gdiplus.dll ncessaire depuis wxpython-2.7
)
